@AC_DEFUN(DV_HAVE_PUBSYNC,[
AC_MSG_CHECKING([ios::streambuf::pubsync or ios::streambuf::sync])
DV_PUBSYNC=""

AC_LANG_PUSH(C++)
if test -z "$DV_PUBSYNC"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <iostream>]], [[
    std::cin.rdbuf()->pubsync();
    ]])],[DV_PUBSYNC="pubsync"],[])
fi

if test -z "$DV_PUBSYNC"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <iostream>]], [[
    std::cin.rdbuf()->sync();
    ]])],[DV_PUBSYNC="sync"],[])
fi
AC_LANG_POP(C++)

if test -n "$DV_PUBSYNC"; then
  AC_MSG_RESULT($DV_PUBSYNC)
fi

if test -z "$DV_PUBSYNC"; then
  AC_MSG_ERROR([neither cin.rdbuf()->pubsync() nor cin.rdbuf()->sync() work])
fi

AC_DEFINE_UNQUOTED(STREAMBUF_PUBSYNC,[$DV_PUBSYNC],[streambuf::pubsync substitute])
])

@AC_DEFUN(DV_HAVE_STD_REL_OPS,[
AC_MSG_CHECKING([whether namespace std::relops exists])
DV_STD_REL_OPS=""

AC_LANG_PUSH(C++)
if test -z "$DV_STD_REL_OPS"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <utility>]], [[
    using namespace std::relops;
    ]])],[DV_STD_REL_OPS="std::rel_ops"],[])
fi

if test -z "$DV_DV_STD_REL_OPS"; then
  DV_STD_REL_OPS="std"
fi
AC_LANG_POP(C++)

AC_MSG_RESULT($DV_STD_REL_OPS)

AC_DEFINE_UNQUOTED(STD_REL_OPS,[$DV_STD_REL_OPS],[std::rel_ops substitute])
])

@AC_DEFUN(DV_STRING_COMPARE_SIGNATURE,[
AC_MSG_CHECKING([string::compare(size_type,size_type,string) works])
DV_STRING_COMPARE=""

AC_LANG_PUSH(C++)
if test -z "$DV_STRING_COMPARE"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <string>]], [[
    std::string s;
    s.compare(0,0,s);
    ]])],[DV_STRING_COMPARE="IIS"],[])
fi

if test -z "$DV_STRING_COMPARE"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <string>]], [[
    std::string s;
    s.compare(s,0,0);
    ]])],[DV_STRING_COMPARE="SII"],[])
fi
AC_LANG_POP(C++)

if test -n "$DV_STRING_COMPARE"; then
  AC_MSG_RESULT($DV_STRING_COMPARE)
fi

if test -z "$DV_STRING_COMPARE"; then
  AC_MSG_ERROR([neither compare(i,i,s) nor compare(i,s,i) works])
fi

if test "$DV_STRING_COMPARE" = IIS; then
  AC_DEFINE(HAVE_FUNC_STRING_COMPARE_IIS,[1],[Define as 1 if string::compare(i,i,s) works])
elif test "$DV_STRING_COMPARE" = SII; then
  AC_DEFINE(HAVE_FUNC_STRING_COMPARE_SII,[1],[Define as 1 if string::compare(i,s,i) works])
else
  AC_MSG_ERROR([unknown signature string::compare])
fi
])
