// $Id: dvconfig.C,v 1.2 2002/10/18 11:52:47 dvermeir Exp $
#include <fstream>
#include <stdexcept>
#include "props.h"

int
main(int argc,char *argv[]) {
const char* usage = "dvconfig file property-name..";

try {
  if (argc<3)
    throw std::runtime_error(usage);
  
  std::ifstream	ifs(argv[1]);
  
  if (!ifs)
    throw std::runtime_error(std::string("dvconfig cannot open \"")+argv[1]+"\"");
  
  Dv::Util::Props props(ifs);
  
  for (int i=2;(i<argc);++i) {
    const std::string*	value(props(argv[i]));
    if (value)
      std::cout << *value << "\n";
    else
      std::cout << "\n";
    }
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }
}

