// $Id: makedaemon.C,v 1.6 2003/03/12 13:33:52 dvermeir Exp $
// Q&D port, we should install configure macros to determine
// HAVE_DAEMON, HAVE_SETSID, TIOCNOTTY

#include	"makedaemon.h"
#include	"systemerror.h"
#include	<config.h>

#include	<fstream>

#include	<stdio.h>
// #define	__USE_XOPEN
#include	<unistd.h> // daemon, ioctl, setsid

#ifndef	HAVE_DAEMON
// next 3 are needed by solaris for open(2) and O_NOCTTY
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<fcntl.h>
#include	<sys/termios.h>
#endif // not HAVE_DAEMON

namespace Dv {
namespace Util {

void
make_daemon(const std::string& pidfilename) throw (std::runtime_error) {
#ifdef	HAVE_DAEMON
if (daemon(0,0) == -1)
  throw SystemError();
#else 
pid_t	pid = fork();
if (pid<0)
  throw SystemError();

if (pid>0) // parent: exit
  exit(0);
	
// child
#ifdef	HAVE_SETSID
if (setsid()<0)
  throw SystemError();
#endif
freopen("/dev/null", "r", stdin);
freopen("/dev/null", "w", stdout);
freopen("/dev/null", "w", stderr);

#ifdef TIOCNOTTY
int fd = open("/dev/tty", O_RDWR|O_NOCTTY);
if (fd >= 0) {
	(void)ioctl(fd, TIOCNOTTY, NULL);
	close(fd);
	}
#endif /* TIOCNOTTY */

chdir("/");

#endif /* not HAVE_DAEMON */

if (pidfilename.size()) {
  std::ofstream ofs(pidfilename.c_str());
  if (!ofs)
    throw std::runtime_error(pidfilename + 
			      ": cannot open [Dv::Util::make_daemon]");
  ofs << getpid() << std::endl;
  }
}

}}
