#ifndef DV_UTIL_RANDOM_H
#define DV_UTIL_RANDOM_H
// $Id: random.h,v 1.3 2002/11/13 16:19:04 dvermeir Exp $

/*! \file
Random number generator using /dev/urandom.
*/

#include <stdexcept>


namespace Dv {
namespace Util {

//! Class supporting random number generation.
/*! Example usage
    \code
    unsigned long key = Dv::Util::Random::rand();
    \endcode
*/
class Random {
//! Produces a random unsigned long taken from /dev/urandom.
/*! An exception is thrown if anything goes wrong, e.g.
   the file /dev/urandom cannot be opened.

   Later extensions should automatically switch to another
   implementation if /dev/urandom is not available.
*/
public:
 static unsigned long rand() throw (std::runtime_error);
};

}}
#endif
