#ifndef	DV_STRSTREAM_H
#define	DV_STRSTREAM_H

// $Id: strstr2str.h,v 1.13 2002/10/18 11:41:26 dvermeir Exp $

/** \mainpage 

\author dvermeir@vub.ac.be
    
<a href="../download/">Download</a>

\section Installation Installation

Standard. See the INSTALL file in the top directory.

\section Introduction Introduction

This package provides some general utilities, see the ``Compound
List'' and ``Namespace Members'' entries on the top menubar.

*/

/** \file
Utility functions for safe conversion of an {o}strstream to
a string (unfreezes the {o}strstream, so that memory is released
upon its destruction). Not very useful, once {o}stringstream is
available:
<ul>
<li> Dv::Util::strstream2str(strstream&)
<li> Dv::Util::strstream2str(ostrstream&)
<li> Dv::Util::strstream2str(strstream&,string&)
<li> Dv::Util::strstream2str(ostrstream&,string&)
</ul>
*/

#include	<string>
#include	<strstream>

/** Namespace for all dvxyz packages. */
namespace Dv {
/** Dv::Util is the namepace for this package. */
namespace Util {
/** Safely convert ss to string */
std::string	strstream2str(std::strstream& ss);
/** Safely convert ss to string */
std::string	strstream2str(std::ostrstream& ss);

// The next 2 functions return a reference to their 2nd argument.

/** Safely convert ss to string s, return s. */
std::string&	strstream2str(std::strstream& ss,std::string &s);
/** Safely convert ss to string s, return s. */
std::string&	strstream2str(std::ostrstream& ss,std::string& s);
}}
#endif
