#ifndef	DV_UTIL_SYSTEMERROR_H
#define	DV_UTIL_SYSTEMERROR_H
// $Id: systemerror.h,v 1.1 2003/03/12 12:56:19 dvermeir Exp $

#include	<string>
#include	<stdexcept> // runtime_error

namespace Dv {
namespace Util {

/**
 * Exception class associated with a system error.
 * 
 * Derived from runtime_error.
 */
class SystemError: public std::runtime_error {
public:
  /**
   * Name of class, is prepended to each message argument of the
   * constructor.
   */
  static const std::string NAME;
  /** 
   * @param error_code system error code, should be valid
   *   input for strerror. If 0, the global :errno will
   *   be used instead.
   */
  SystemError(int error_code = 0);
  /** @return error code of this SystemError 
   * @warning This function is not called errno() because
   * <string.h> defines errno as a macro.
   */
  int err_no() const { return errno_; }
private:
  int errno_;
};

}}
#endif
