// $Id: test-date.C,v 1.1 2002/10/18 13:45:30 dvermeir Exp $
// A test program for the Date class

#include "date.h"

const char* day_formats[] = {
	" 2001-03-30 ",
        " March 30 ",
        " 3/30/2001 ",
	" 2001-03-30 ",
	" 2001-3-30 ",
        // " 30-3-2001 ", => not accepted
        // " 3-30-2001 ", => not accepted
        " 30 March 2001",
        " 30 Mar 2001",
        " Mar 30, 2001",
        // " 30/3/2001 ", => not accepted
	0
	};

const char* date_formats[] = {
        " March 30 13:18:00",
        " March 30 1:18 pm",
	0
	};
int
main(int,char**) {

using namespace std;
using namespace Dv::Util;

try {
  {
  /*
  {
  // 1st januari of this year.
  Date now;
  Date	d(now.year(),0,1);
  cout << d.str() << endl;
  d.yday(210);
  cout << d.str() << " " << d.yday() << endl;
  }
  */
  // 1. try day (excl. time) parser.
  Date	dref("2001-03-30");
  for (int i=0; (day_formats[i]); ++i) {
    Date d(day_formats[i]);
    if (d!=dref) {
      cerr << "phase 1. reference " << dref.str() << " != " << d.str() << endl;
      // will fail after 2001
      // return 1;
      }
    }
  }
  // 2. try date (incl. time) parse.
  {
  Date	dref("2001-03-30 13:18");
  // can we parse the default output?
  {
  Date	d(dref.str());
  if (d!=dref) {
    cerr << "phase 2a. reference " << dref.str() << " != " << d.str() << endl;
    return 1;
    }
  }
  for (int i=0; (date_formats[i]); ++i) {
    Date d(date_formats[i]);
    if (d!=dref) {
      cerr << "phase 2b. reference " << dref.str() << " != " << d.str() << endl;
      return 1;
      }
    }
  }
  // 3. try date (incl. time) parse.
  {
  Date	dref("2001-03-30 13:18");
  Date  d(2001,2,30,13,18,00);
  if (d!=dref) {
    cerr << "phase 3. reference " << dref.str() << " != " << d.str() << endl;
    cerr << dref.time() << " != " << d.time() << endl;
    return 1;
    }
  }
  // 4. try various inspector functions
  {
  Date	d("2001-03-30 13:18");
  if (d.year()!=2001) {
    cerr << d.str() << " year() => " << d.year() << " != " << 2001 << endl;
    return 1;
    }
  if (d.month()!=2) {
    cerr << d.str() << " month() => " << d.month() << " != " << 2 << endl;
    return 1;
    }
  if (d.day()!=30) {
    cerr << d.str() << " day() => " << d.day() << " != " << 30 << endl;
    return 1;
    }
  if (d.hours()!=13) {
    cerr << d.str() << " hours() => " << d.hours() << " != " << 13 << endl;
    return 1;
    }
  if (d.minutes()!=18) {
    cerr << d.str() << " minutes() => " << d.minutes() << " != " << 18 << endl;
    return 1;
    }
  if (d.seconds()!=0) {
    cerr << d.str() << " seconds() => " << d.seconds() << " != " << 18 << endl;
    return 1;
    }
  if (d.yday()!=88) {
    cerr << d.yday() << " yday() => " << d.yday() << " != " << 88 << endl;
    return 1;
    }
  if (d.wday()!=5) {
    cerr << d.wday() << " wday() => " << d.wday() << " != " << 5 << endl;
    return 1;
    }
  }
  // 5. try various update functions
  {
  Date	dref("2001-03-30 13:18");
  Date	d(0);
  d.year(2001);
  d.month(2);
  d.day(30);
  d.hours(13);
  d.minutes(18);
  d.seconds(0);
  if (d!=dref) {
    cerr << "phase 5. reference " << dref.str() << " != " << d.str() << endl;
    return 1;
    }
  }
  // 6. check time() functions
  {
  Date	dref("2001-03-30 13:18");
  Date	d(dref.time());
  if (d!=dref) {
    cerr << "phase 5. reference " << dref.str() << " != " << d.str() << endl;
    return 1;
    }
  }
  }
catch (DateError& e) {
  cerr << e.what() << endl;
  return 1;
  }
return 0;
}
