// $Id: test-dir-tempdir.C,v 1.1 2003/09/19 14:04:31 dvermeir Exp $
#include <string>
#include <iostream>
#include "file.h"

int
main(int, char**) {
try {
  Dv::Util::Directory d(".");
  std::string tmpname(d.tempdir("test-dir-tempdir"));
  Dv::Util::File f(tmpname);
  if (!f.exists())
    throw std::runtime_error(tmpname + " does not exist");
  if (!f.isdir())
    throw std::runtime_error(tmpname + " not a directory");
  std::cout << "directory " << tmpname << " created" << std::endl;
  f.rmfr();
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }
return 0;
}
