// $Id: test-dispatch.C,v 1.2 2003/08/11 09:15:31 dvermeir Exp $
#include <stdexcept>
#include <iostream>

#include "dispatch.h"

typedef int Input;
typedef int Value;

class Application {
friend class Dv::Util::Dispatcher<Application,Input,Value>;
public:
 bool main(Input& input, const Value& value) {
   return Dv::Util::Dispatcher<Application,Input,Value>::handle(*this, input, value);
   }
private:
  bool handle_1(Input& input, const Value& value) { input = 1; return true; }
  bool handle_2(Input& input, const Value& value) { input = 2; return true; }
  bool handle_4(Input& input, const Value& value) { input = 4; return true; }
  bool handle_8(Input& input, const Value& value) { input = 8; return true; }

};

Dv::Util::Dispatcher<Application,Input,Value>::Entry 
Dv::Util::Dispatcher<Application,Input,Value>::table[] = {
  { 1, &Application::handle_1 },
  { 2, &Application::handle_2 },
  { 4, &Application::handle_4 },
  { 8, &Application::handle_8 },
  { 0, 0 } // sentinel
};

int
main(int, char**) {
try {
  Application application;
  Input input;
  Input values[] = { 1 , 2, 3, 4, 5, 6, 7, 8, 9 , 0 };
  bool results[] = { true , true, false, true, false, false, false, true, false , false };
  
  for (size_t i=0; (values[i]); ++i) {
    bool b(application.main(input, values[i]));
    if (b != results[i])
      throw std::runtime_error("FAILED");
    if ( b && (input != values[i]) )
      throw std::runtime_error("FAILED");
    // std::cout << b << ": " << input << std::endl;
    }
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  }
}

