// $Id: test-fdstreambuf-01.C,v 1.3 2002/10/18 13:17:18 dvermeir Exp $
#include <string>
#include <iostream>
#include <unistd.h> // pipe()

#include "fdstreambuf.h"

using namespace std;
using namespace Dv::Util;
/**
 * Test program for timeout on write operation.
 * We write to a pipe until it is full and
 * check that we eventually get a timeout.
 */

/**
 * Print mesg on cerr and return retcode.
 * Convenient for error exits as in
 * \code
 * if (fail)
 *   return error(ERROR+"something is wrong",2);
 * \endcode
 */
int
error(const string& mesg, int retcode = 1) {
cerr << mesg << endl;
return retcode;
}

static const string ERROR("Error: ");
static const string NAME("test-fdstreambuf-01");

int 
main(int,char**) {

int fd[2];
if (pipe(fd) < 0)
  return error(ERROR+"pipe() failed",1);
const int delay(1000); // 1 second

ostream	    os(0);
fdstreambuf fdsbuf(fd[1],1024,1024,delay,true,&cout);
//fdsbuf.debug(&cout);

os.rdbuf(&fdsbuf);

unsigned int n(0);
for (; os << 'a' ; ++n)
  ;

cout << NAME << " timedout = " << fdsbuf.timedout() << endl
     << NAME << " error    = " << fdsbuf.error() << endl
     << NAME << " strerror = " << fdsbuf.strerror() << endl
     << NAME << " n        = " << n << endl;

// We should get a timeout.
return fdsbuf.timedout()?0:1;
}

