// $Id: test-file-compare.C,v 1.2 2002/10/18 13:17:18 dvermeir Exp $
#include "file.h"

using namespace Dv::Util;
using namespace std;

int
main(int, char**) {
try {
  string  fn("test-file-compare-file");
  string  ln("test-file-compare-hlink");
  string  sn("test-file-compare-slink");
  File  f(fn);
  File  l(ln);
  File  s(sn);
  f.rmfr();
  l.rmfr();
  s.rmfr();
  if (f.exists())
    throw runtime_error(f.str()+" exists and shouldn't");
  if (l.exists())
    throw runtime_error(l.str()+" exists and shouldn't");
  if (s.exists())
    throw runtime_error(s.str()+" exists and shouldn't");
  f.touch();
  if (!f.exists())
    throw runtime_error(f.str()+" does not exist and should");
  l.mklink(f.path());
  if (!l.exists())
    throw runtime_error(l.str()+" does not exist and should");
  s.mksymlink(f.path());
  if (!s.exists())
    throw runtime_error(s.str()+" does not exist and should");
  s.expand();
  if (f < l) {
    cerr << f.str() << " < " << l.str() << endl;
    throw runtime_error(f.str()+" == " + l.str() + " expected");
    }
  if (l < f) {
    cerr << l.str() << " < " << f.str() << endl;
    throw runtime_error(f.str()+" == " + l.str() + " expected");
    }
  if (f == l )
    cerr << f.str() << " == " << l.str() << endl;
  if (f < s) {
    cerr << f.str() << " < " << s.str() << endl;
    throw runtime_error(f.str()+" == " + s.str() + " expected");
    }
  if (s < f) {
    cerr << s.str() << " < " << f.str() << endl;
    throw runtime_error(f.str()+" == " + s.str() + " expected");
    }
  if (s == l )
    cerr << f.str() << " == " << s.str() << endl;
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 1;
  }
return 0;
}
