// $Id: test-fullpath.C,v 1.2 2002/10/18 13:17:18 dvermeir Exp $
#include "file.h"

using namespace std;
using namespace Dv::Util;

bool
check_fullpath(const string& input, const string& output, 
  bool except_ok = false) {
string tmp;
try {
  File::fullpath(input,tmp);
  if (tmp!=output) {
    cerr << "fullpath(" << input << "): " << tmp
         << ", expected " << output << endl;
    return false;
    }
  else
    cerr << "fullpath(" << input << "): " << tmp << "\n";
  }
catch (exception& e) {
  cerr << e.what() << (except_ok ? ": ok" : ": error" ) << endl;
  if (except_ok)
    return true;
  }
return true;
}

int
main() {
check_fullpath("","/",true);
check_fullpath("/A/B/../C", "/A/C");
check_fullpath("/A/B/./C", "/A/B/C");
check_fullpath("/A/../../C", "/", true);
check_fullpath("///////////////", "/");
check_fullpath("/A////B/./C", "/A/B/C");
string pwd = Directory::pwd();
check_fullpath("A////B/./C", pwd + "/A/B/C");
}
