// $Id: test-includestream.C.in,v 1.1 2003/03/12 13:35:47 dvermeir Exp $

#include <fstream>
#include <stdexcept>
#include "dvutil/includestream.h"
#include "dvutil/file.h"

int
main(int,char**) {
try {
  std::cout << "srcdir = " << "." << std::endl;
  Dv::Util::Directory srcdir(".");
  if (! srcdir.cd() )
    throw std::runtime_error("Cannot cd to .");
  const std::string fn("test-include.0");
  std::ifstream ifs(fn.c_str());
  if (!ifs)
    throw std::runtime_error(fn + ": cannot open");
  Dv::Util::includestream is(ifs,".");
  if (!is)
    throw std::runtime_error(fn + ": cannot open includestream");
  std::cout << is.rdbuf();
  int x;
  int last_x=0;
  while (is >> x) {
    if (x!=last_x+1)
      throw std::runtime_error("unexpected input");
    last_x = x;
    }
  return 0;
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }
}
