// $Id: test-make_daemon.C,v 1.2 2003/03/12 13:33:52 dvermeir Exp $

#include <sys/types.h>
#include <signal.h> // kill
#include <unistd.h> // fork
#include <iostream>
#include <fstream>

#include "systemerror.h"
#include "makedaemon.h"

int
main(int, char**) {
try {
  const std::string pidfile("/tmp/test-make_daemon.pid");
  
  pid_t child = fork();
  
  if (child < 0)
    throw Dv::Util::SystemError();
  
  if (child == 0) { // child
    Dv::Util::make_daemon(pidfile);
    while (true)
      sleep(1);
    return 0;
    }
  
  // parent
  sleep(2);
  std::ifstream ifs(pidfile.c_str());
  
  if (!ifs) {
    std::cerr << pidfile << ": cannot open" << std::endl;
    return 1;
    }
  
  pid_t daemon_pid;
  
  ifs >> daemon_pid;
  
  std::cout << "killing pid " << daemon_pid << std::endl;
  if ( kill(daemon_pid, 9) == -1)
    throw Dv::Util::SystemError();
  return 0;
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }
}
