// $Id: test-ntostr.C,v 1.3 2003/08/17 12:53:38 dvermeir Exp $
#include <iostream>
#include <iomanip>
#include <sstream>

#include "ntostr.h"

int
main() {
int		i(3);
unsigned int 	j(3000000000u);
long		l(1000000000);
unsigned long 	ul(3000000000ul);
double		dd(3.12345678);

using namespace Dv::Util;
std::ostringstream	oss1;
std::ostringstream	oss2;
oss1  << i <<  " "
      << j <<  " "
      << l <<  " "
      << ul <<  " "
      << std::setprecision(8) << dd;

oss2  << ntostr(i) <<  " "
      << ntostr(j) <<  " "
      << ntostr(l) <<  " "
      << ntostr(ul) <<  " "
      << ntostr(dd);

std::string	s1(oss1.str());
std::string	s2(oss2.str());

if (s1!=s2) {
  std::cerr << "s1 = " << s1 << "\n"
       << "and"
       << "s2 = " << s2 << "\n"
       << "are different!"
       << std::endl;
  return 1;
  }

try {
  double d = Double("3.14");
  int i(Int("43"));
  long l(Long("44"));
  std::cout << d + i + l << std::endl;
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }

try {
  int i43(Int("43"));
  std::string s02("02");
  int i02 = (Int(s02));
  std::cerr << i02 << std::endl;
  if (i43 + i02 != 45)
    throw std::runtime_error("Int error");
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }

return 0;
}
