// $Id: test-props-substitute.C,v 1.3 2003/03/12 13:33:52 dvermeir Exp $

#include <sstream>
#include "props.h"

using namespace std;
using namespace Dv::Util;

int
main(int,char**) {
static const string solution("name='1'2\\34\" abcd' and age = 21");
try {
  Props	props;
  props["a"] = "a${b}";
  props["b"] = "b${c}";
  props["c"] = "c${d}";
  props["d"] = "d";
  props["name"] = "1'2\\34\" ${a}";
  props["age"] = 21;
  const string query("name='${name}' and age = %{age}");
  string sout = props.substitute(query);

  if (sout!=solution)
    throw runtime_error(sout + ": expected " + solution);

  istringstream	iss(query);
  ostringstream oss;

  props.substitute(iss,oss);

  if (oss.str()!=solution)
    throw runtime_error(sout + ": expected stream " + solution);

  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 1;
  }
return 0;
}
