// $Id: test-props.C,v 1.2 2003/10/07 12:06:45 dvermeir Exp $

#include	<iostream>
#include	<exception>
#include	<fstream>
#include	<stdexcept> // runtime_error

#include	"props.h"
#include	"ntostr.h"


int 
main(int argc,char *argv[]) {

using namespace std;
using namespace Dv::Util;

string	text;

try {
  {
  // 1. Create new props.
  Dv::Util::Props	props;

  for (int i=0;(i<100);++i) // associate "99" with "99"
    props[i]=ntostr(i);

  for (int i=0;(i<10);++i)
    cout << props[i] << " ";
  cout << endl;

  // check whether all there
  for (int i=0;(i<100);++i)
    if (static_cast<int>(props[i])!=i)
      throw runtime_error(string("1. insert ")+ntostr(i)+", got "+
		string(props[i]));

  // 2. make "99" associate with "990" 
  for (int i=0;(i<100);++i)
    props.append(ntostr(i),"0","");
  for (int i=0;(i<100);++i)
    if (static_cast<int>(props[ntostr(i)])!=10*i)
      throw runtime_error(string("2. expect ")+ntostr(i)+"0, got "+
		string(props[ntostr(i)]));

  // 3. remove trailing 0
  for (int i=0;(i<100);++i) {
    string& s(props[i]);
    s.erase(s.size()-1);
    }
  for (int i=0;(i<100);++i)
    if (static_cast<int>(props[i])!=i)
      throw runtime_error(string("3. expect ")+ntostr(i)+", got "+
		string(props[i]));
  // 4. write to file
  // add huge text field and remember in text
  for (int i=0;(i<100);++i)
    props.append("text",ntostr(i)+"\n");
  text = props["text"].str();

  ofstream	ofs("/tmp/tprops.config");
  if (!ofs)
    throw runtime_error("4. Cannot open /tmp/tprops.config for writing");
  ofs << "# generated by tprops\n\n\n";
  ofs << props;
  }
  {
  // 5. Read const from file
  ifstream	ifs("/tmp/tprops.config");
  if (!ifs)
    throw runtime_error("5. Cannot open /tmp/tprops.config for reading");
  const Dv::Util::Props props(ifs);
  for (int i=0;(i<100);++i)
    if (static_cast<int>(props[i])!=i)
      throw runtime_error(string("5. expect ")+ntostr(i)+", got "+
		string(props[i]));
  const string& huge(props["text"]);
  if (huge!=text)
      throw runtime_error(string("5. expect ")+text+", got "+huge);
  }
  {
  // 6. Read non-const from file
  ifstream	ifs("/tmp/tprops.config");
  if (!ifs)
    throw runtime_error("6. Cannot open /tmp/tprops.config for reading");
  Dv::Util::Props props(ifs);
  for (int i=0;(i<100);++i)
    if (static_cast<int>(props[i])!=i)
      throw runtime_error(string("6. expect ")+ntostr(i)+", got "+
		string(props[i]));
  for (int i=0;(i<100);++i)
    props.erase(ntostr(i));
  props.erase("text");
  if (props.size())
      throw runtime_error(string("6. expect 0 size, got ")+ntostr(props.size()));
  }
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 1;
  }
return 0;
}

