// $Id: test-ref.C,v 1.1 2002/10/18 13:45:30 dvermeir Exp $
// $Log: test-ref.C,v $
// Revision 1.1  2002/10/18 13:45:30  dvermeir
// Saving..
//
// Revision 1.3  2002/10/18 12:56:54  dvermeir
// Saving..
//
// Revision 1.2  2001/06/09 11:46:56  dvermeir
// Moved to namespace Dv::Util instead of Dv.
//
// Revision 1.1  2001/03/25 14:01:57  dvermeir
// Added tref.C test program.
//

#include	<iostream>
#include	<string>
#include	"ref.h"

using namespace std;
using Dv::Util::ref;

int	n_ctor(0);
int	n_dtor(0);

class Huge {
friend class ref<Huge>;
public:
  friend ostream& operator<<(ostream& os, const Huge& h) { return os << h.s_; }
  static ref<Huge> create(const char *s) { return ref<Huge>(new Huge(s)); }
  void s(const string& x) { s_ = x; }
  const string& s() const { return s_; }
private:
  string    s_;
  Huge(const char* s): s_(s) {++n_ctor; }
  ~Huge()  { ++n_dtor; }
};

int
main(int argc,char *argv[]) {
  {
  ref<Huge>  r = Huge::create("c++");
  ref<Huge>  p(r);
  ref<Huge>  k = r;
  
  r->s("d++");
  string    t1(r->s());
  string    t2((*p).s());
  string    t3((*k).s());
  if ((t1!=t2) || (t2!=t3) || (t1!=t3)) {
    cerr << "t1=" << t1 << ", t2=" << t2 << ", t3 =" << t3 << " not equal" <<endl;
    return 1;
    }
  }
if (n_ctor!=1) {
  cerr << "n_ctor [" << n_ctor << "]  != 1" << endl;
  return 1;
  }
if (n_ctor!=n_dtor) {
  cerr << "n_ctor [" << n_ctor << "]  != n_dtor [" << n_dtor << "]" << endl;
  return 1;
  }
return 0;
}
