// $Id: test-teestream.C,v 1.2 2003/03/12 13:33:52 dvermeir Exp $
#include <fstream>
#include <unistd.h>
#include "teestream.h"

const char *const fn1("tee1.txt");
const char *const fn2("tee2.txt");
const unsigned int n(100);

int
main(int,char**) {
{
std::ofstream  ofs1(fn1);
std::ofstream  ofs2(fn2);
Dv::Util::teestream  ts(ofs1,ofs2);

if (!ts) {
  std::cerr << "teestream not ok" << std::endl;
  return 1;
  }

for (unsigned int i=0; (i<n); ++i) 
  if (ts) 
    ts << i << std::endl;
}

{
std::ifstream	ifs1(fn1);
std::ifstream	ifs2(fn2);
int		i(0);
int		i1(0);
int		i2(0);

while ((ifs1>>i1) && (ifs2>>i2)) {
  if ((i1!=i2) || (i!=i1))
    return 1;
  ++i;
  }
}
unlink(fn1);
unlink(fn2);
return 0;
}
